#include <cstdint>
#include <brick-hashset>
#include <pthread.h>
#include <assert.h>

using HS = brick::hashset::Concurrent< int >;

void *thread( void *_hs )
{
    HS &hs = *(HS *) _hs;
    for ( int i = 1; i <= ITEMS; ++i )
        hs.insert( i );
    for ( int i = 1; i <= ITEMS; ++i )
        assert( hs.count( i ) );
    for ( int i = ITEMS + 1; i <= ITEMS + CHECK; ++i )
        assert( !hs.count( i ) );
    return nullptr;
}

int main()
{
    HS hs;
    hs.initialSize( 8 );
    auto hs1 = hs, hs2 = hs;
    pthread_t p1, p2;
    pthread_create(&p1, NULL, thread, &hs1);
    pthread_create(&p2, NULL, thread, &hs2);
    pthread_join(p1, NULL);
    pthread_join(p2, NULL);
    return 0;
}
